

# MagnitudeResponseView + Filter Kernels
### A Magnitude Response View for SuperCollider3<br>
Minimal Example:
```
// MagnitudeResponseView plots an SOSKernel
v = SOSKernel.new.view;

// Plug these in an SOS UGen
v.action_({ arg ...args; args.at(1).coefs.postln; });
```

![MagnitudeResponseView](/HelpSource/Classes/img/MagnitudeResponseView-02.png)<br>
### Controls

MagnitudeResponseView as a control

- **Click** on a <kbd>FilterKernel</kbd>'s cursor* selects a FilterKernel.
- **Click and drag** a <kbd>FilterKernel</kbd>'s cursor* to adjust its **Cutoff** frequency (Hz) [X axis] and/or **Gain** (dBs) [Y axis] where applicable.<br>
> *In MagnitudeResponseView's of the shelf configuration, a Filter's Cursor is the red circle at its Cutoff as shown on the pictures.<br>
- **Mouse Wheel** or Two finger vertical swipe on touchpads, adjusts the Filter's **Q** value where applicable.<br>
- **Right Mouse Button Click** on <kbd>MagnitudeResponseView</kbd> and you get a popup menu with all the filters available in your installation for the **Selected** <kbd>FilterKernel</kbd>.<br>

![MagnitudeResponseView-menu](/HelpSource/Classes/img/MagnitudeResponseView+menu.png)<br>

RMB Click on an SOSKernel control.<br>

> By default, for an <kbd>SOSKernel</kbd> for example, the set of installed filters are all of the <kbd>BEQSuite</kbd> Filters + an extra Lowshelf example: <kbd>LowBoost</kbd>, supplied by this package.

<hr>

<kbd>MagnitudeResponseView</kbd> keyboard controls

* **n** - select next kernel
* **p** - select previous kernel
* **-/+** - range zoom gain<br>

These operate on the **selected** <kbd>FilterKernel</kbd>:

* **b** or **d** - bypass **selected** <kbd>FilterKernel</kbd>
* **Up** **Down** - adjusts **Gain / Q** depending on key mods [shift]/[ctr].
* **Left** **Right** - adjusts Cutoff freq.
* **m** - Popoup filter select menu.
* **z** - Zero Gain

<hr>

<kbd>MagnitudeResponseView</kbd>'s info line updates in real time to reflect user modifications. The info line displays:

* Active FilterKernel index number in brackets. ie, [0]
* Filter name. ie, `BPeakEQ`
* Cutoff frequency in Hz
* Q
* Gain in dBs

Adusting MagnitudeResponseView triggers the View's instance user installable action function. Just like it would on any other `SuperCollider3` View:<br>

# Instalation
Clone [MagnitudeResponseView](https://bitbucket.org/blackrain-audio/MagnitudeResponseView/ "MagnitudeResponseView") repository and move its folder inside the Extensions folder in `SuperCollider3` *User Support directory* or place MagnitudeResponseView repository folder anywhere you want in your file system and add its path to your includes folder in `sclang` config section in SCIDE prefs.

ie, in the IDE:
> Click Edit Menu -> Preferences and click on interpreter.

and recompile Class Library.

If you don't have GIT available in your system, you can simply download a snapshot of the [MagnitudeResponseView](https://bitbucket.org/blackrain-audio/MagnitudeResponseView/ "MagnitudeResponseView") repository as a zip file from the *Downloads* links at the bottom left on this page and install that as a quark:
<br><br>

```
Quarks.install("~/path/to/MagnitudeResponseView/MagnitudeResponseView.quark")
```


Recompile Class Library and you are done.

Latest documentation and more at  [blackrain-audio](https://blackrain-audio.bitbucket.io/ "blackrain audio") site.<br>