// OnePole
// Magnitude Response
cos_w       = (2pi * cutoff * sampleDur).cos;
numerator   = (b0*b0);
denominator = (1+(a1*a1)+(2*a1*cos_w));
magnitude   = (numerator / denominator).pow(1/2).ampdb;

// Phase Response
w = 2pi * cutoff * sampleDur;
sin_w = w.sin;
cos_w = w.cos;
response = atan2(a1 * sin_w, 1 + (a1*cos_w));      // for b > 0
response = atan2(a1 * sin_w, 1 + (a1*cos_w)) + pi; // for b < 0

/*
EQUATION 19-2
Single pole low-pass filter. The filter's
response is controlled by the parameter, x,
a value between zero and one.

a0 = 1 - x
b1 = x

(a1=0)

EQUATION 19-3
Single pole high-pass filter.

a0 =  (1-x)/2
a1 = -(1-x)/2
b1 =  x

*/

x = exp(-2pi * freq * sampleDur);

exp(2pi)
log(exp(2pi))
2pi
