// A First Order Section (OnePole, 6db per Octave) Hi and Low Pass Filters
// From The Scientist and Engineer's Guide to Digital Signal Processing
// By Steven W. Smith, Ph.D.
// Chapter 19: Recursive Filters - Equation 19-5
// blackrain

FOSlowpass {
    *ar { arg in, cutoff=1000.0, mul=1.0, add=0;
        var coef = exp(-2pi * cutoff * SampleDur.ir);
        ^FOS.ar(in, 1 - coef, 0.0, coef, mul, add);
    }
    *kr { arg in, cutoff=100.0, mul=1.0, add=0;
        var coef = exp(-2pi * cutoff * SampleDur.ir);
        ^FOS.kr(in, 1 - coef, 0.0, coef, mul, add);
    }
    *coefs { arg cutoff=1000.0, sampleDur=(44100.0.reciprocal);
        var coef = exp(-2pi * cutoff * sampleDur);
        ^[1 - coef, 0.0, coef];
    }
}

FOShighpass {
    *ar { arg in, cutoff=1000.0, mul=1.0, add=0;
        var coefs = this.coefs(cutoff, SampleDur.ir);
        ^FOS.ar(in, *coefs ++ [mul, add]);
    }
    *kr { arg in, cutoff=100.0, mul=1.0, add=0;
        var coefs = this.coefs(cutoff, SampleDur.ir);
        ^FOS.kr(in, *coefs ++ [mul, add]);
    }
    *coefs { arg cutoff=1000.0, sampleDur=(44100.0.reciprocal);
        var a0, a1, b1, x;
        x = exp(-2pi * cutoff * sampleDur);
        a0 = (1+x)/2;
        a1 = a0.neg;
        b1 = x;
        ^[a0,a1,b1]
     }
}
