// blackrain
+ FOS {
	*magnitudeResponse { arg coefs, viewWidth, minFreq=20.0, maxFreq, sampleRate;
		var response, sampleDur, nyq, a0, a1, b1;
		sampleRate=sampleRate?44100.0;
		sampleDur=sampleRate.reciprocal;
		nyq = sampleRate * 0.5;
		maxFreq = maxFreq ?? { nyq };
		maxFreq = maxFreq.min(nyq);
		#a0, a1, b1 = coefs;

		response = Array.fill(viewWidth, { arg x;
			var freq, cos_w0, numerator, denominator;
			freq = x.linexp(0, viewWidth - 1, minFreq, maxFreq);
			cos_w0 = (2pi*freq*sampleDur).cos;
			numerator   = (a0*a0)+(a1*a1)+(2*a0*a1*cos_w0);
			denominator = 1+(b1*b1)-(2*b1*cos_w0);
			(numerator/denominator).pow(1/2).ampdb;
		});
		
		^response
	}
	*phaseResponse { arg coefs, viewWidth, minFreq=20.0, maxFreq, sampleRate;
		var response, sampleDur, nyq, a0, a1, b1;
		sampleRate=sampleRate?44100.0;
		sampleDur=sampleRate.reciprocal;
		nyq = sampleRate * 0.5;
		maxFreq = maxFreq ?? { nyq };
		maxFreq = maxFreq.min(nyq);
		#a0, a1, b1 = coefs;

		response = Array.fill(viewWidth, { arg x;
			var freq, w, sin_w, cos_w, numerator, denominator;
			freq = x.linexp(0, viewWidth - 1, minFreq, maxFreq);
			w=2pi*freq*sampleDur;
			sin_w=w.sin;
			cos_w=w.cos;
			numerator=(a1+(b1*a0))*sin_w.neg;
			denominator=a0-(b1*a1)+((a1-(b1*a0))*cos_w);
			atan(numerator/denominator).ampdb
		});

		^response
	}
}
