//------------------------------------------------------------------
//	DAFX, Digital Audio Effects (Wiley ed.)
//	chapter 2 	: filters
//	section 2.3 : Equalizers
//	page 53 	: second order shelving filter design
//------------------------------------------------------------------

// low-freq shelving boost
// blackrain

LowBoost {
	*ar { arg in, freq=400.0, db=0.0, mul=1.0, add=0.0;
		var coefs;
		coefs = this.coefs(freq, db, SampleDur.ir);
		^SOS.ar(in, *coefs ++ [mul, add]);
	}
	*kr { arg in, freq=400.0, db=0.0, mul=1.0, add=0.0;
		var coefs;
		coefs = this.coefs(freq, db, SampleDur.ir);
		^SOS.kr(in, *coefs ++ [mul, add]);
	}
	*coefs { arg freq=400.0, db=0.0, sampleDur=(44100.reciprocal);
		var v0g, fc, denom, fc_pow2, tmp1, tmp2;
		var a0, a1, a2, b1, b2;

		v0g = pow(10.0, db / 20.0);
		fc	= (pi*freq*sampleDur).tan;
		fc_pow2 = fc.pow(2);
		tmp1 = (2.sqrt*fc) + fc_pow2;
		tmp2 = ((2*v0g).sqrt * fc) + (v0g*fc_pow2);
		denom = 1.0 + tmp1;

		a0 = (1 + tmp2) / denom;
		a1 =  2 * (v0g*fc_pow2 - 1) / denom;
		a2 = (1 - tmp2) / denom;
		b1 = -2 * (fc_pow2 - 1) / denom;
		b2 = (1 - tmp1).neg / denom;
		
		^[a0, a1, a2, b1, b2]
	}
}
