// A First Order (OnePole, 6db per Octave) Low Pass Filter
// From The Scientist and Engineer's Guide to Digital Signal Processing
// By Steven W. Smith, Ph.D.
// Chapter 19: Recursive Filters - Equation 19-5
// blackrain

OnePoleLPF {
	*ar { arg in, cutoff=1000.0, mul=1.0, add=0;
		^OnePole.ar(in, exp(-2pi * cutoff * SampleDur.ir), mul, add);
	}
	*kr { arg in, cutoff=100.0, mul=1.0, add=0;
		^OnePole.kr(in, exp(-2pi * cutoff * SampleDur.ir), mul, add);
	}
    *coefs { arg cutoff=1000.0, sampleDur=(44100.0.reciprocal);
        var coef = exp(-2pi * cutoff * sampleDur);
        ^[1 - coef, 0.0, coef];
    }
}

OnePoleHPF {
    // TODO: ar, kr, coefs
    *coefs { arg cutoff=1000.0, sampleDur=(44100.0.reciprocal);
        var a0, a1, b1, x;
        x = exp(-2pi * cutoff * sampleDur);
        a0 = (1+x)/2;
        a1 = a0.neg;
        b1 = x;
        ^[a0,a1,b1]
    }
}