// blackrain
// + biquad magnitude response calc

+ SOS {
	*magnitudeResponse { arg coefs, viewWidth, minFreq=20.0, maxFreq, sampleRate;
		var a0, a1, a2, b1, b2, response, sampleDur;
		sampleRate = sampleRate ? 44100.0;
		maxFreq = maxFreq ?? { sampleRate * 0.5 };
		sampleDur = sampleRate.reciprocal;
		#a0, a1, a2, b1, b2 = coefs;

		response = Array.fill(viewWidth, { arg x;
			var freq, w, w_cos, w2_cos, numerator, denominator;

			freq = x.linexp(0, viewWidth - 1, minFreq, maxFreq);

			w = 2pi * freq * sampleDur;
			w_cos = w.cos;
			w2_cos = (2*w).cos;
			numerator = (a0*a0)+(a1*a1)+(a2*a2)+(2*((a0*a1)+(a1*a2))*w_cos)
			  +(2*a0*a2*w2_cos);
			denominator = 1.0+(b1*b1)+(b2*b2)+(2*((b1*b2)-b1)*w_cos)
			  -(2*b2*w2_cos);
			(numerator / denominator).pow(1/2).ampdb;
		});

		^response
	}
}
