// blackrain

FilterKernelView : SCViewHolder {
	var <model;

	*new { arg model, parent, bounds, title;
		^super.new.init(model, parent, bounds, title);
	}
	init { arg inmodel, parent, bounds, title;
		var controller, viewRefresh, ownWindow=false;

		model = inmodel;

		parent = parent ?? {
			bounds = bounds ? Rect(10,300,420,220);
			title=title?"Magnitude Response View";
			parent = Window(title, bounds)
			.alwaysOnTop_(true);
			bounds = bounds.moveTo(0,0).insetBy(10);
			ownWindow=true;
			parent
		};
		bounds = bounds ? Rect(10,10,400,200);
		this.view = MagnitudeResponseView(parent, bounds)
		  .background_(Color.blue(0.5,0.1));

        viewRefresh = { this.view.refresh; };

		controller = SimpleController.new(model);
        controller.put(\coefs, viewRefresh);
        controller.put(\sampleRate, viewRefresh);
        controller.put(\filterClass, viewRefresh);
        controller.put(\enabled, viewRefresh);
        controller.put(\filterKey, viewRefresh);

		this.view.onClose = { controller.remove; };

		if (ownWindow) {
			this.view.resize_(5);
			parent.front;
		};

		this.view.kernels_(model);
	}
}
